<?php include_once 'codebase/hyperframe.php' ?><h1>The File Browser</h1>

<p>Hyperframe&#39;s file browser is a multipurpose window that is presented in several different formats depending on the required function. It performs the functions of:</p>

<ul>
  <li><strong>Image selection</strong></li>
  <li><strong>Image upload</strong></li>
  <li><strong>Linked page selection</strong></li>
  <li><strong>File restore</strong></li>
  <li><strong>Opening of non-menu pages</strong></li>
  <li><strong>New page creation</strong></li>
  <li><strong>Local page upload</strong></li>
</ul>

<p>The common elements are a lefthand filesystem tree listing, and righthand pane with various preview and selection tools. Below left, we see the file browser in image selector mode. You will note that the tree view has two options,&nbsp; Standard and Full. <em>Standard</em> will typically show you only the location where the required files would normally be located. <em>Full</em> will give you access to matching files within the entire website structure. Click a folder icon to see the files in any given level. On single-clicking a file, a preview will typically be shown in the righthand column. The preview mechanism is aware of most common file types, and will display images and HTML documents as they should appear. The content of unrecognised files will be shown as plain text. Images too large for the preview pane can be seen in their entirety by clicking the preview once. To use a selected file, press the button below the preview.</p>

<p><img alt="image selector mode" class="float-left caption" onclick="hf_imgzoom_popup(this.src)" src="img/editing/imageselector.png" style="width: 398px; height: 313px; border-width: 1px; border-style: solid;" />The <strong>uploader</strong> allows you to select one or more local files to upload. Be aware that the dialog for selecting local files is provided by your computer&#39;s operating system, not Hyperframe, and may allow you to select unsuitable file types for upload. If this arises, the unsuitable files will be rejected on upload.</p>

<p>File size and number limits are determined partly by the webhost, so you may find apparently conflicting values here. For example, Hyperframe may allow you 10MB per file, but the host only 2MB per upload. The smaller figure will apply.</p>

<p>The <strong>Destination</strong> field will typically contain the advised value already, but if you want to change it, be aware that it is a relative path which does <em>not</em> begin with a slash. If you enter a nonexistent path, the directories will be automatically created.</p>

<p><strong>Smart Sizing </strong>allows you to set an upper limit to the uploaded image size. If the image you supply is smaller in both dimensions than the Smart Size, no action will be taken. If it is larger in one or both dimensions, then it will be scaled down, preserving the aspect ratio, until it fits within both smart size limits.&nbsp; At no time does this process crop the image.</p>

<p>The image selector typically opens as a popup window, which will close automatically once an image is selected.&nbsp;</p>

<p><strong>File selectors</strong> are similar to the image selector, except that they will not have the Smart Size function, or where the selection of a server-side file is intended, the uploader. In contrast to the image selector these selectors typically open in a new browser tab, and will remain open until you decide to close them.<strong><img alt="file restore mode" class="caption float-right" onclick="hf_imgzoom_popup(this.src)" src="img/editing/filerestore.png" style="width: 404px; height: 258px; border-width: 1px; border-style: solid;" /></strong></p>

<p><strong>File Restore</strong> shows a filesystem tree which is locked to one place - the &#39;undo&#39; list. The contents of this location mirror the structure of the website, so files in &#39;undo&#39; itself represent earlier versions of files in the root of the website. Whenever a file is saved from the online editor, a copy of the previous version is placed in the undo list. Any existing &#39;undo&#39; version is renamed with a serial number, 01, 02 and so on up to 09. Thus, the same-named file is the most recent archive copy, the higher the number the older the copy. A pair of preview windows allow you to compare the live version of a document with the archived version. When you have decided which version to restore, press &#39;Restore File&#39; to copy it back to the live site.</p>

<p>Menus are also covered by the archival/restore process. Images and other document types are not.</p>

<p><strong>Undoing a restore</strong> - If you decide that the restored copy is not what you wanted, the latest version can be reinstated by selecting the same-named file with an &#39;_unrestore&#39; extension.</p>

<p>&nbsp;</p>
